//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TformMain *formMain;
NOTIFYICONDATA IconData; // TrayIcon
HANDLE Mutex;
__fastcall TformMain::TformMain(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TformMain::MyIconMsg(TMessage &Msg)
{
    switch(Msg.LParam)
    {
        case WM_LBUTTONUP:  // @, ٭
            Application->Restore();
            break;
        case WM_RBUTTONUP:  // @k, Xk
            POINT p;
            ::GetCursorPos(&p);
            PopupMenu1->Popup(p.x, p.y);
            break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TformMain::CreateMyIcon(void)
{
    IconData.cbSize = sizeof(NOTIFYICONDATA);
    IconData.hWnd = Handle;
    IconData.uID = 1;
    IconData.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
    IconData.uCallbackMessage = WM_USER+101;
    IconData.hIcon = this->Icon->Handle;
    strcpy(IconData.szTip, formMain->Caption.c_str() );
}
//---------------------------------------------------------------------------
void __fastcall TformMain::FormCreate(TObject *Sender)
{
    Application->Title = formMain->Caption;
    HANDLE PrevInstHandle;
    Mutex = OpenMutex(SYNCHRONIZE, false, Application->Title.c_str());

    if (Mutex != NULL)
    {
        String AppTitle = Application->Title;
        Application->ShowMainForm = false;
        SetWindowText(Application->Handle, NULL);
        PrevInstHandle = FindWindow("TApplication", AppTitle.c_str());
        if (IsIconic(PrevInstHandle))
            ShowWindow(PrevInstHandle, SW_RESTORE);
        else
        {
            BringWindowToTop(PrevInstHandle);
            SetForegroundWindow(PrevInstHandle);
        }
        Application->Terminate();
    }
    else
        Mutex = CreateMutex(NULL, false, Application->Title.c_str());

    if( !FileExists(ExtractFilePath(Application->ExeName) + "FUS.ini") )
        ShowMessage("䤣 FUS.ini ɮ!"), Close();

    iniSetting.reset(new TIniFile( ExtractFilePath(Application->ExeName) + "Quick_String.ini" ));
    formMain->Height = iniSetting->ReadInteger("Setting", "Height", 340);
    formMain->Width  = iniSetting->ReadInteger("Setting", "Width", 234);
    formMain->Left = iniSetting->ReadInteger("Setting", "Left", Screen->Width - formMain->Width - 20);
    formMain->Top  = iniSetting->ReadInteger("Setting", "Top", Screen->Height - formMain->Height - 20);
    if( formMain->Left > Screen->Width - formMain->Width - 20 )
        formMain->Left = Screen->Width - formMain->Width - 20;
    if( formMain->Top > Screen->Height - formMain->Height - 20 )
        formMain->Top = Screen->Height - formMain->Height - 20;
    ListBox1->ItemHeight = iniSetting->ReadInteger("Setting", "TextHeight", 19);
    ListBox1->Font->Size = iniSetting->ReadInteger("Setting", "FontSize", 10);

    sl.reset(new TStringList);
    iniString.reset(new TIniFile( ExtractFilePath(Application->ExeName) + "FUS.ini" ));
    iniString->ReadSections( cbClass->Items );
    cbClass->ItemIndex = (cbClass->Items->IndexOf(iniSetting->ReadString("Setting", "Class", "")) == -1)
                        ? 0 : cbClass->Items->IndexOf(iniSetting->ReadString("Setting", "Class", ""));
    cbClassChange(0);
    PrevCls = cbClass->Text;

    CreateMyIcon(); // إߤ@ TrayIcon
}
//---------------------------------------------------------------------------
void __fastcall TformMain::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if( Key == 27 ) //  ESC YkU
        Application->Minimize();
}
//---------------------------------------------------------------------------
void __fastcall TformMain::FormClose(TObject *Sender, TCloseAction &Action)
{
    if( Modified )
    {
        iniString->EraseSection(PrevCls);
        for( int i = 0; i < ListBox1->Count; i++ )
            iniString->WriteString(PrevCls, ListBox1->Items->Strings[i], "");
    }

    iniSetting->WriteInteger("Setting", "Height", formMain->Height);
    iniSetting->WriteInteger("Setting", "Width", formMain->Width);
    iniSetting->WriteInteger("Setting", "Left", formMain->Left);
    iniSetting->WriteInteger("Setting", "Top", formMain->Top);
    iniSetting->WriteString("Setting", "Class", cbClass->Text);
    iniSetting->WriteInteger("Setting", "TextHeight", ListBox1->ItemHeight);
    iniSetting->WriteInteger("Setting", "FontSize", ListBox1->Font->Size);

    Shell_NotifyIcon(NIM_DELETE, &IconData);
    ReleaseMutex(Mutex);
}
//---------------------------------------------------------------------------
void __fastcall TformMain::mmAddClick(TObject *Sender)
{
    TformAddString *form2 = new TformAddString(Application);
    form2->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TformMain::mmIncSpaceClick(TObject *Sender)
{
    ListBox1->ItemHeight += 3;
}
//---------------------------------------------------------------------------
void __fastcall TformMain::mmDecSpaceClick(TObject *Sender)
{
    ListBox1->ItemHeight -= 3;
}
//---------------------------------------------------------------------------
void __fastcall TformMain::mmResetClick(TObject *Sender)
{
    ListBox1->ItemHeight = 19;
    ListBox1->Font->Size = 10;
}
//---------------------------------------------------------------------------
void __fastcall TformMain::mmWebClick(TObject *Sender)
{
    ShellExecute(NULL, NULL, "http://www.csie.nctu.edu.tw/~chtai/", NULL, NULL, SW_SHOW);
}
//---------------------------------------------------------------------------
void __fastcall TformMain::mmEmailClick(TObject *Sender)
{
    ShellExecute(NULL, NULL, "mailto:chiahsien@gmail.com?Subject=rJ{@ǷN", NULL, NULL,SW_SHOW);
}
//---------------------------------------------------------------------------
void __fastcall TformMain::mmHelpClick(TObject *Sender)
{
    AnsiString s =  "[@:\tWr\n]@:\tUr\nw :\tYpr\n :\tjr\nIns:\tקr\nDel:\tRr\nEnter:\teXr\nESC:\tYpܥkU";
    ShowMessage(s);
}
//---------------------------------------------------------------------------
void __fastcall TformMain::N1Click(TObject *Sender)
{
    Application->Restore();
}
//---------------------------------------------------------------------------
void __fastcall TformMain::X1Click(TObject *Sender)
{
    Shell_NotifyIcon(NIM_DELETE, &IconData);
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TformMain::ApplicationEvents1Minimize(TObject *Sender)
{
    ShowWindow(Application->Handle, SW_HIDE);
    Shell_NotifyIcon(NIM_ADD, &IconData);
}
//---------------------------------------------------------------------------
void __fastcall TformMain::ApplicationEvents1Restore(TObject *Sender)
{
    Shell_NotifyIcon(NIM_DELETE, &IconData);
    SetForegroundWindow(Handle);
}
//---------------------------------------------------------------------------
void __fastcall TformMain::ApplicationEvents1Idle(TObject *Sender,
      bool &Done)
{
    HWND ForeWindow = ::GetForegroundWindow();
    if(ForeWindow != Handle)
    {
        LastEditHandle = ForeWindow;
		char str[255];
    	SendMessage(LastEditHandle, WM_GETTEXT, 255, (long)str);
    	ListBox1->Hint = AnsiString("ǰe - ") + str;
    }
}
//---------------------------------------------------------------------------
void __fastcall TformMain::ListBox1DblClick(TObject *Sender)
{
    HWND hFocusWin;

    if(!IsWindow(LastEditHandle)) return;
    if( IsZoomed(LastEditHandle) )
        ShowWindow(LastEditHandle, SW_SHOWMAXIMIZED); 	// YO̤j, N̤j
    else
        ShowWindow(LastEditHandle, SW_SHOWNORMAL);		// MN
    SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, 0, SPIF_SENDCHANGE);

    Clipboard()->AsText = ListBox1->Items->Strings[ListBox1->ItemIndex];
    BringWindowToTop(LastEditHandle);
//    SetForegroundWindow(LastEditHandle);
    if( AttachThreadInput(GetCurrentThreadId(), GetWindowThreadProcessId(LastEditHandle, NULL), true) )
    {
        BringWindowToTop(LastEditHandle);
//        SetForegroundWindow(LastEditHandle);
        if(ListBox1->Hint.Pos("Maxthon"))
            ::SetFocus(LastEditHandle);
        Application->ProcessMessages();
        hFocusWin = GetFocus();
        AttachThreadInput(GetCurrentThreadId(), GetWindowThreadProcessId(LastEditHandle, NULL), false);
        if( hFocusWin != NULL )
        {
            int i;
            Byte ch;
            AnsiString str = ListBox1->Items->Strings[ListBox1->ItemIndex];
            for( i = 1; i <= str.Length(); i++ )    // `N: Oq 1 }l, Oq 0 }l
            {
                ch = Byte(str[i]);
                if( IsDBCSLeadByte(ch) )    // YO줸r, N MAKEWORD
                    PostMessage(hFocusWin, WM_IME_CHAR, MAKEWORD(Byte(str[++i]), ch), 0);
                else    // MNeX
                    PostMessage(hFocusWin, WM_IME_CHAR, WORD(ch), 0);
            }
        }
        else
            ShowMessage("GetFocus() failed!");
    }
    else
        ShowMessage("AttachThreadInput() failed!!");
}
//---------------------------------------------------------------------------
void __fastcall TformMain::cbClassChange(TObject *Sender)
{
    if( Modified )
    {
        iniString->EraseSection(PrevCls);
        for( int i = 0; i < ListBox1->Count; i++ )
            iniString->WriteString(PrevCls, ListBox1->Items->Strings[i], "");
        Modified = false;
    }
    PrevCls = cbClass->Text;

    iniString->ReadSectionValues(cbClass->Text, sl.get());
    // ⵲ = h, ]Ǫt = , ҥH ReadSection
    for( int i = 0; i < sl->Count; i++ )
        sl->Strings[i] = sl->Strings[i].SubString(0, sl->Strings[i].Length()-1);
    ListBox1->Items = sl.get();
}
//---------------------------------------------------------------------------
void __fastcall TformMain::ListBox1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    switch(Key)
    {
        case VK_DELETE:     // R
            if( ListBox1->ItemIndex >= 0 )
            {
                ListBox1->Items->Delete(ListBox1->ItemIndex);
                Modified = true;
            }
            break;

        case VK_INSERT:     // ק
            if( ListBox1->ItemIndex >= 0 )
            {
                AnsiString temp = ListBox1->Items->Strings[ListBox1->ItemIndex];
                ListBox1->Items->Strings[ListBox1->ItemIndex] = InputBox("קr", " "+temp+" 令 :", temp);
                Modified = true;
            }
            break;

        case 219:         //  [ W
            if( ListBox1->ItemIndex > 0 )
            {
                ListBox1->Items->Exchange(ListBox1->ItemIndex, ListBox1->ItemIndex-1);
                Modified = true;
            }
            break;

        case 221:       //  ] U
            if( ListBox1->ItemIndex < ListBox1->Count-1 )
            {
                ListBox1->Items->Exchange(ListBox1->ItemIndex, ListBox1->ItemIndex+1);
                Modified = true;
            }
            break;

        case VK_SUBTRACT:   // Ypr
            if( ListBox1->Font->Size > 8 )
                ListBox1->Font->Size--;
            else
                ShowMessage("rӤpFݤ !");
            break;

        case VK_ADD:        // jr
            ListBox1->Font->Size++;
            break;

        case VK_RETURN:     // eXr
            ListBox1->OnDblClick(Sender);
            break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TformMain::ListBox1KeyPress(TObject *Sender, char &Key)
{
    Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TformMain::ListBox1DrawItem(TWinControl *Control,
      int Index, TRect &Rect, TOwnerDrawState State)
{
    ListBox1->Canvas->TextRect(Rect, 0, Rect.top, ListBox1->Items->Strings[Index]);
}
//---------------------------------------------------------------------------
void __fastcall TformMain::E1Click(TObject *Sender)
{
    Application->Minimize();
}
//---------------------------------------------------------------------------
void __fastcall TformMain::X2Click(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------

